-- @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
--   ASSETS->TBL_ASSETS_SALE_WRITE_OFF_DETAILS TBL_ASSETS_SALE_WRITE_OFF_DETAILS TBL_ASSETS_SALE_WRITE_OFF_DETAILS TBL_ASSETS_SALE_WRITE_OFF_DETAILS TBL_ASSETS_SALE_WRITE_OFF_DETAILS TBL_ASSETS_SALE_WRITE_OFF_DETAILS  
-- @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
------------------------------------------------------------------------------------------
            CREATE OR REPLACE FUNCTION fn_get_all_assets_sale_write_off_details() RETURNS SETOF assets.tbl_assets_sale_write_off_details AS $$
                DECLARE

                BEGIN
                    RETURN QUERY SELECT * FROM assets.tbl_assets_sale_write_off_details WHERE int_sys_action_id != -1;  
                END;
            $$ LANGUAGE plpgsql;
        

------------------------------------------------------------------------------------------
            CREATE OR REPLACE FUNCTION fn_get_all_assets_sale_write_off_details_with_action_user() 
                            RETURNS TABLE (pk_assets_sale_Write_off_id BIGINT,
								fk_assets_sale_Write_off_master_id BIGINT,

								fk_assets_id BIGINT,

								vhr_ledg_currency VARCHAR,
								dbl_ledg_cur_roe DOUBLE PRECISION,
								dbl_ledg_cur_price DOUBLE PRECISION,
								dbl_ledg_cur_profit DOUBLE PRECISION,

								vhr_base_currency VARCHAR,
								dbl_base_cur_price DOUBLE PRECISION,
								dbl_base_cur_profit DOUBLE PRECISION,

								vhr_assets_ledg_currency VARCHAR,
								dbl_assets_ledg_cur_roe DOUBLE PRECISION,
								dbl_assets_ledg_cur_current_value DOUBLE PRECISION,
								dbl_assets_ledg_cur_profit DOUBLE PRECISION,

								vhr_assets_base_currency VARCHAR,
								dbl_assets_base_cur_current_value DOUBLE PRECISION,
								dbl_assets_base_cur_profit DOUBLE PRECISION,

								sin_sales_count SMALLINT,
								sin_assets_previous_status SMALLINT) AS $$
                DECLARE

                BEGIN
                    RETURN QUERY SELECT mt.pk_assets_sale_Write_off_id,
					mt.fk_assets_sale_Write_off_master_id,

					mt.fk_assets_id,

					mt.vhr_ledg_currency,
					mt.dbl_ledg_cur_roe,
					mt.dbl_ledg_cur_price,
					mt.dbl_ledg_cur_profit,

					mt.vhr_base_currency,
					mt.dbl_base_cur_price,
					mt.dbl_base_cur_profit,

					mt.vhr_assets_ledg_currency,
					mt.dbl_assets_ledg_cur_roe,
					mt.dbl_assets_ledg_cur_current_value,
					mt.dbl_assets_ledg_cur_profit,

					mt.vhr_assets_base_currency,
					mt.dbl_assets_base_cur_current_value,
					mt.dbl_assets_base_cur_profit,

					mt.sin_sales_count,
					mt.sin_assets_previous_status
                        FROM assets.tbl_assets_sale_write_off_details mt 
                            LEFT JOIN authentication.tbl_user u1
                                ON mt.fk_created_user_id =  u1.pk_user_id
                            LEFT JOIN authentication.tbl_user u2
                                ON mt.fk_last_modified_user_id =  u2.pk_user_id
                            LEFT JOIN authentication.tbl_user u3
                                ON mt.fk_deleted_user_id =  u3.pk_user_id
                        WHERE mt.int_sys_action_id != -1  
                        ORDER BY ;
                END;
            $$ LANGUAGE plpgsql;
        

------------------------------------------------------------------------------------------

            CREATE OR REPLACE PROCEDURE sp_insert_or_update_assets_sale_write_off_details(jsnAssetsSaleWriteOffDetails JSONB, jsnSqlRes OUT JSON) AS $$
                DECLARE
                    objSpOutRes TYP_SP_OUT_RES;
                    objFnCheckRes TYP_FN_CHECK_RES;
                    dtmCurrent TIMESTAMP WITH TIME ZONE;
                BEGIN
                    SELECT NOW() INTO dtmCurrent;

                    -- // Duplication Checking in DB FUCTION(Insert and Update)
                    SELECT * FROM  fn_check_data_uniqueness('assets.tbl_assets_sale_write_off_details'::VARCHAR, ''::VARCHAR, ::VARCHAR, 'pk_assets_sale_Write_off_id'::VARCHAR, CAST(jsnAssetsSaleWriteOffDetails->>'binAssetsSaleWriteOffId' AS BIGINT)::BIGINT) INTO objFnCheckRes;
                    IF objFnCheckRes.sin_sql_check_status = -1::SMALLINT THEN
                        objSpOutRes.sinSqlCustomStatus := -1::SMALLINT;
                        objSpOutRes.strSqlCustomStatusCode := 'ERROR';
                        objSpOutRes.strSqlCustomMessage := objFnCheckRes.vhr_sql_check_message;

                        objSpOutRes.strSqlCustomErrorType := 'DATABASE_VALIDATION_ERROR';

                        SELECT * FROM  fn_convert_type_out_object_to_out_json(objSpOutRes) INTO jsnSqlRes;
                        RAISE NOTICE 'jsnSqlRes: %', jsnSqlRes;
                        RETURN;
                    END IF;

                    IF CAST(jsnAssetsSaleWriteOffDetails->>'binAssetsSaleWriteOffId' AS BIGINT)::BIGINT = 0::BIGINT THEN
                        -- // Count Exced or other checking License related in DB FUCTION(Insert)
                        

                        --jsnAssetsSaleWriteOffDetails.intSysActionId = 0;
                        --jsnAssetsSaleWriteOffDetails.binCreatedUserId = jsnAssetsSaleWriteOffDetails.linLoginUserId;
                        --jsnAssetsSaleWriteOffDetails.dtmCreated = jsnAssetsSaleWriteOffDetails.dtmCurrentDateTime; --SELECT NOW();

                        INSERT INTO assets.tbl_assets_sale_write_off_details (fk_assets_sale_Write_off_master_id,

						fk_assets_id,

						vhr_ledg_currency,
						dbl_ledg_cur_roe,
						dbl_ledg_cur_price,
						dbl_ledg_cur_profit,

						vhr_base_currency,
						dbl_base_cur_price,
						dbl_base_cur_profit,

						vhr_assets_ledg_currency,
						dbl_assets_ledg_cur_roe,
						dbl_assets_ledg_cur_current_value,
						dbl_assets_ledg_cur_profit,

						vhr_assets_base_currency,
						dbl_assets_base_cur_current_value,
						dbl_assets_base_cur_profit,

						sin_sales_count,
						sin_assets_previous_status)
                            VALUES(CAST(jsnAssetsSaleWriteOffDetails->>'binAssetsSaleWriteOffMasterId' AS BIGINT),

						CAST(jsnAssetsSaleWriteOffDetails->>'binAssetsId' AS BIGINT),

						jsnAssetsSaleWriteOffDetails->>'strLedgCurrency',
						CAST(jsnAssetsSaleWriteOffDetails->>'dblLedgCurRoe' AS DOUBLE PRECISION),
						CAST(jsnAssetsSaleWriteOffDetails->>'dblLedgCurPrice' AS DOUBLE PRECISION),
						CAST(jsnAssetsSaleWriteOffDetails->>'dblLedgCurProfit' AS DOUBLE PRECISION),

						jsnAssetsSaleWriteOffDetails->>'strBaseCurrency',
						CAST(jsnAssetsSaleWriteOffDetails->>'dblBaseCurPrice' AS DOUBLE PRECISION),
						CAST(jsnAssetsSaleWriteOffDetails->>'dblBaseCurProfit' AS DOUBLE PRECISION),

						jsnAssetsSaleWriteOffDetails->>'strAssetsLedgCurrency',
						CAST(jsnAssetsSaleWriteOffDetails->>'dblAssetsLedgCurRoe' AS DOUBLE PRECISION),
						CAST(jsnAssetsSaleWriteOffDetails->>'dblAssetsLedgCurCurrentValue' AS DOUBLE PRECISION),
						CAST(jsnAssetsSaleWriteOffDetails->>'dblAssetsLedgCurProfit' AS DOUBLE PRECISION),

						jsnAssetsSaleWriteOffDetails->>'strAssetsBaseCurrency',
						CAST(jsnAssetsSaleWriteOffDetails->>'dblAssetsBaseCurCurrentValue' AS DOUBLE PRECISION),
						CAST(jsnAssetsSaleWriteOffDetails->>'dblAssetsBaseCurProfit' AS DOUBLE PRECISION),

						CAST(jsnAssetsSaleWriteOffDetails->>'sinSalesCount' AS SMALLINT),
						CAST(jsnAssetsSaleWriteOffDetails->>'sinAssetsPreviousStatus' AS SMALLINT)) RETURNING pk_assets_sale_Write_off_id INTO objSpOutRes.binSqlPk;
                    ELSE
                        -- // UPDATE Check already update another usersin DB FUCTION(Update and Delete)
                        SELECT * FROM  fn_check_already_update_or_delete_another_user('assets.tbl_assets_sale_write_off_details'::VARCHAR, 'pk_assets_sale_Write_off_id'::VARCHAR, CAST(jsnAssetsSaleWriteOffDetails->>'binAssetsSaleWriteOffId' AS BIGINT)::BIGINT, CAST(jsnAssetsSaleWriteOffDetails->>'intSysActionId' AS INT)::INT) INTO objFnCheckRes;
                        IF objFnCheckRes.sin_sql_check_status = -1::SMALLINT THEN
                            objSpOutRes.sinSqlCustomStatus := -1::SMALLINT;
                            objSpOutRes.strSqlCustomStatusCode := 'ERROR';
                            objSpOutRes.strSqlCustomMessage := objFnCheckRes.vhr_sql_check_message;

                            objSpOutRes.strSqlCustomErrorType := 'DATABASE_VALIDATION_ERROR';

                            SELECT * FROM  fn_convert_type_out_object_to_out_json(objSpOutRes) INTO jsnSqlRes;
                            RAISE NOTICE 'jsnSqlRes: %', jsnSqlRes;
                            RETURN;
                        END IF;

                        --jsnAssetsSaleWriteOffDetails.intSysActionId = jsnAssetsSaleWriteOffDetails.intSysActionId + 1;
                        --jsnAssetsSaleWriteOffDetails.binLastModifiedUserId = jsnAssetsSaleWriteOffDetails.linLoginUserId;
                        --jsnAssetsSaleWriteOffDetails.dtmLastModified = jsnAssetsSaleWriteOffDetails.dtmCurrentDateTime; --SELECT NOW();

                        UPDATE assets.tbl_assets_sale_write_off_details SET fk_assets_sale_Write_off_master_id = CAST(jsnAssetsSaleWriteOffDetails->>'binAssetsSaleWriteOffMasterId' AS BIGINT),

						fk_assets_id = CAST(jsnAssetsSaleWriteOffDetails->>'binAssetsId' AS BIGINT),

						vhr_ledg_currency = jsnAssetsSaleWriteOffDetails->>'strLedgCurrency',
						dbl_ledg_cur_roe = CAST(jsnAssetsSaleWriteOffDetails->>'dblLedgCurRoe' AS DOUBLE PRECISION),
						dbl_ledg_cur_price = CAST(jsnAssetsSaleWriteOffDetails->>'dblLedgCurPrice' AS DOUBLE PRECISION),
						dbl_ledg_cur_profit = CAST(jsnAssetsSaleWriteOffDetails->>'dblLedgCurProfit' AS DOUBLE PRECISION),

						vhr_base_currency = jsnAssetsSaleWriteOffDetails->>'strBaseCurrency',
						dbl_base_cur_price = CAST(jsnAssetsSaleWriteOffDetails->>'dblBaseCurPrice' AS DOUBLE PRECISION),
						dbl_base_cur_profit = CAST(jsnAssetsSaleWriteOffDetails->>'dblBaseCurProfit' AS DOUBLE PRECISION),

						vhr_assets_ledg_currency = jsnAssetsSaleWriteOffDetails->>'strAssetsLedgCurrency',
						dbl_assets_ledg_cur_roe = CAST(jsnAssetsSaleWriteOffDetails->>'dblAssetsLedgCurRoe' AS DOUBLE PRECISION),
						dbl_assets_ledg_cur_current_value = CAST(jsnAssetsSaleWriteOffDetails->>'dblAssetsLedgCurCurrentValue' AS DOUBLE PRECISION),
						dbl_assets_ledg_cur_profit = CAST(jsnAssetsSaleWriteOffDetails->>'dblAssetsLedgCurProfit' AS DOUBLE PRECISION),

						vhr_assets_base_currency = jsnAssetsSaleWriteOffDetails->>'strAssetsBaseCurrency',
						dbl_assets_base_cur_current_value = CAST(jsnAssetsSaleWriteOffDetails->>'dblAssetsBaseCurCurrentValue' AS DOUBLE PRECISION),
						dbl_assets_base_cur_profit = CAST(jsnAssetsSaleWriteOffDetails->>'dblAssetsBaseCurProfit' AS DOUBLE PRECISION),

						sin_sales_count = CAST(jsnAssetsSaleWriteOffDetails->>'sinSalesCount' AS SMALLINT),
						sin_assets_previous_status = CAST(jsnAssetsSaleWriteOffDetails->>'sinAssetsPreviousStatus' AS SMALLINT) 
                        WHERE pk_assets_sale_Write_off_id = CAST(jsnAssetsSaleWriteOffDetails->>'binAssetsSaleWriteOffId' AS BIGINT);
                    END IF;

                    --COMMIT;
                    objSpOutRes.sinSqlCustomStatus := 1::SMALLINT;
                    objSpOutRes.strSqlCustomStatusCode := 'SUCCESS';
                    objSpOutRes.strSqlCustomMessage := 'AssetsSaleWriteOffDetails Saved';
                    objSpOutRes.dtmCurrent = dtmCurrent;
                    
                    SELECT * FROM  fn_convert_type_out_object_to_out_json(objSpOutRes) INTO jsnSqlRes;
                    RAISE NOTICE 'jsnSqlRes: %', jsnSqlRes;
                    RETURN;
                EXCEPTION WHEN OTHERS THEN
                    ROLLBACK;
                    objSpOutRes.sinSqlCustomStatus := -1::SMALLINT;
                    objSpOutRes.strSqlCustomStatusCode := 'ERROR';
                    objSpOutRes.strSqlCustomMessage := 'AssetsSaleWriteOffDetails Save Failed';

                    objSpOutRes.strSqlCustomErrorType := 'DATABASE_SYSTEM_ERROR';

                    GET STACKED DIAGNOSTICS 
				        objSpOutRes.strSqlSysMessage := MESSAGE_TEXT,
                    	objSpOutRes.strSqlSysExceptionDetail := PG_EXCEPTION_DETAIL,
                    	objSpOutRes.strSqlSysExceptionHint := PG_EXCEPTION_CONTEXT;
                
                    SELECT * FROM  fn_convert_type_out_object_to_out_json(objSpOutRes) INTO jsnSqlRes;
                    RAISE EXCEPTION 'jsnSqlRes: %', jsnSqlRes;
                    RETURN;
                END;
            $$ LANGUAGE plpgsql;
        

------------------------------------------------------------------------------------------

            CREATE OR REPLACE PROCEDURE sp_delete_assets_sale_write_off_details(binAssetsSaleWriteOffId BIGINT, intSysActionId INT, binDeletedUserId BIGINT, jsnSqlRes OUT JSON) AS $$
                DECLARE
                    objSpOutRes TYP_SP_OUT_RES;
                    objFnCheckRes TYP_FN_CHECK_RES;
                    dtmCurrent TIMESTAMP WITH TIME ZONE;
                BEGIN
                    SELECT NOW() INTO dtmCurrent;

                    -- // FOREIGN KEY REFERENCES Checking in DB FUCTION(Delete)
                    SELECT * FROM  fn_check_foreignkey_referance('tbl_assets_sale_write_off_details'::VARCHAR, 'pk_assets_sale_Write_off_id'::VARCHAR, binAssetsSaleWriteOffId::BIGINT, '{}'::VARCHAR ARRAY) INTO objFnCheckRes;
                    IF objFnCheckRes.sin_sql_check_status = -1::SMALLINT THEN
                        objSpOutRes.sinSqlCustomStatus := -1::SMALLINT;
                        objSpOutRes.strSqlCustomStatusCode := 'ERROR';
                        objSpOutRes.strSqlCustomMessage := objFnCheckRes.vhr_sql_check_message;

                        objSpOutRes.strSqlCustomErrorType := 'DATABASE_VALIDATION_ERROR';

                        SELECT * FROM  fn_convert_type_out_object_to_out_json(objSpOutRes) INTO jsnSqlRes;
                        RAISE NOTICE 'jsnSqlRes: %', jsnSqlRes;
                        RETURN;
                    END IF;

                    -- // UPDATE Check already update another users in DB FUCTION(Update and Delete)
                    SELECT * FROM  fn_check_already_update_or_delete_another_user('assets.tbl_assets_sale_write_off_details'::VARCHAR, 'pk_assets_sale_Write_off_id'::VARCHAR, CAST(binAssetsSaleWriteOffId AS BIGINT)::BIGINT, intSysActionId::INT) INTO objFnCheckRes;
                    IF objFnCheckRes.sin_sql_check_status = -1::SMALLINT THEN
                        objSpOutRes.sinSqlCustomStatus := -1::SMALLINT;
                        objSpOutRes.strSqlCustomStatusCode := 'ERROR';
                        objSpOutRes.strSqlCustomMessage := objFnCheckRes.vhr_sql_check_message;

                        objSpOutRes.strSqlCustomErrorType := 'DATABASE_VALIDATION_ERROR';

                        SELECT * FROM  fn_convert_type_out_object_to_out_json(objSpOutRes) INTO jsnSqlRes;
                        RAISE NOTICE 'jsnSqlRes: %', jsnSqlRes;
                        RETURN;
                    END IF;

                    --dtmDeleted = SELECT NOW();
                    UPDATE assets.tbl_assets_sale_write_off_details SET int_sys_action_id = -1::INT,
                                fk_deleted_user_id = binDeletedUserId,
                                dtm_deleted = dtmCurrent
                        WHERE pk_assets_sale_Write_off_id = binAssetsSaleWriteOffId;

                    --COMMIT;
                    objSpOutRes.sinSqlCustomStatus := 1::SMALLINT;
                    objSpOutRes.strSqlCustomStatusCode := 'SUCCESS';
                    objSpOutRes.strSqlCustomMessage := 'AssetsSaleWriteOffDetails Deleted';
                    objSpOutRes.dtmCurrent = dtmCurrent;

                    SELECT * FROM fn_convert_type_out_object_to_out_json(objSpOutRes) INTO jsnSqlRes;
                    RAISE NOTICE 'jsnSqlRes: %', jsnSqlRes;
                    RETURN;
                EXCEPTION WHEN OTHERS THEN
                    ROLLBACK;
                    objSpOutRes.sinSqlCustomStatus := -1::SMALLINT;
                    objSpOutRes.strSqlCustomStatusCode := 'ERROR';
                    objSpOutRes.strSqlCustomMessage := 'AssetsSaleWriteOffDetails Delete Failed';

                    objSpOutRes.strSqlCustomErrorType := 'DATABASE_SYSTEM_ERROR';

                    GET STACKED DIAGNOSTICS 
				        objSpOutRes.strSqlSysMessage := MESSAGE_TEXT,
                    	objSpOutRes.strSqlSysExceptionDetail := PG_EXCEPTION_DETAIL,
                    	objSpOutRes.strSqlSysExceptionHint := PG_EXCEPTION_CONTEXT;

                    SELECT * FROM fn_convert_type_out_object_to_out_json(objSpOutRes) INTO jsnSqlRes;
                    RAISE EXCEPTION 'jsnSqlRes: %', jsnSqlRes;
                    RETURN;
                END;
            $$ LANGUAGE plpgsql;
        

