-- @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
--   ASSETS->TBL_ASSETS_SALE_WRITE_OFF_MASTER TBL_ASSETS_SALE_WRITE_OFF_MASTER TBL_ASSETS_SALE_WRITE_OFF_MASTER TBL_ASSETS_SALE_WRITE_OFF_MASTER TBL_ASSETS_SALE_WRITE_OFF_MASTER TBL_ASSETS_SALE_WRITE_OFF_MASTER  
-- @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
------------------------------------------------------------------------------------------
            CREATE OR REPLACE FUNCTION fn_get_all_assets_sale_write_off_master() RETURNS SETOF assets.tbl_assets_sale_write_off_master AS $$
                DECLARE

                BEGIN
                    RETURN QUERY SELECT * FROM assets.tbl_assets_sale_write_off_master WHERE int_sys_action_id != -1;  
                END;
            $$ LANGUAGE plpgsql;
        

------------------------------------------------------------------------------------------
            CREATE OR REPLACE FUNCTION fn_get_all_assets_sale_write_off_master_with_action_user() 
                            RETURNS TABLE (pk_assets_sale_Write_off_master_id BIGINT,
								fk_documents_id BIGINT,
								fk_depreciation_master_id BIGINT,

								fk_cost_centre_id BIGINT,
								sin_if_sale SMALLINT,

								fk_received_cheque_id BIGINT,
								fk_cc_swap_id BIGINT,
								vhr_depositor_name VARCHAR,
								vhr_depositor_ref_no VARCHAR,

								vhr_payee_vpa VARCHAR,
								vhr_payee_vpa_bank VARCHAR,

								vhr_virtual_number VARCHAR,
								vhr_virtual_provider VARCHAR,
								vhr_virtual_reference VARCHAR,

								vhr_ledg_currency VARCHAR,
								dbl_ledg_cur_roe DOUBLE PRECISION,
								dbl_ledg_cur_amount DOUBLE PRECISION,
								dbl_ledg_cur_bank_charge DOUBLE PRECISION,

								vhr_base_currency VARCHAR,
								dbl_base_cur_amount DOUBLE PRECISION,
								dbl_base_cur_bank_charge DOUBLE PRECISION,

								fk_service_tax_id BIGINT,
								dbl_sys_perce_of_tax DOUBLE PRECISION,
								dbl_perce_of_tax DOUBLE PRECISION,
								dbl_ledg_cur_tax_base_amount DOUBLE PRECISION,
								dbl_ledg_cur_tax_amount DOUBLE PRECISION,

								dbl_base_cur_tax_base_amount DOUBLE PRECISION,
								dbl_base_cur_tax_amount DOUBLE PRECISION) AS $$
                DECLARE

                BEGIN
                    RETURN QUERY SELECT mt.pk_assets_sale_Write_off_master_id,
					mt.fk_documents_id,
					mt.fk_depreciation_master_id,

					mt.fk_cost_centre_id,
					mt.sin_if_sale,

					mt.fk_received_cheque_id,
					mt.fk_cc_swap_id,
					mt.vhr_depositor_name,
					mt.vhr_depositor_ref_no,

					mt.vhr_payee_vpa,
					mt.vhr_payee_vpa_bank,

					mt.vhr_virtual_number,
					mt.vhr_virtual_provider,
					mt.vhr_virtual_reference,

					mt.vhr_ledg_currency,
					mt.dbl_ledg_cur_roe,
					mt.dbl_ledg_cur_amount,
					mt.dbl_ledg_cur_bank_charge,

					mt.vhr_base_currency,
					mt.dbl_base_cur_amount,
					mt.dbl_base_cur_bank_charge,

					mt.fk_service_tax_id,
					mt.dbl_sys_perce_of_tax,
					mt.dbl_perce_of_tax,
					mt.dbl_ledg_cur_tax_base_amount,
					mt.dbl_ledg_cur_tax_amount,

					mt.dbl_base_cur_tax_base_amount,
					mt.dbl_base_cur_tax_amount
                        FROM assets.tbl_assets_sale_write_off_master mt 
                            LEFT JOIN authentication.tbl_user u1
                                ON mt.fk_created_user_id =  u1.pk_user_id
                            LEFT JOIN authentication.tbl_user u2
                                ON mt.fk_last_modified_user_id =  u2.pk_user_id
                            LEFT JOIN authentication.tbl_user u3
                                ON mt.fk_deleted_user_id =  u3.pk_user_id
                        WHERE mt.int_sys_action_id != -1  
                        ORDER BY vhr_depositor_name;
                END;
            $$ LANGUAGE plpgsql;
        

------------------------------------------------------------------------------------------

            CREATE OR REPLACE PROCEDURE sp_insert_or_update_assets_sale_write_off_master(jsnAssetsSaleWriteOffMaster JSONB, jsnSqlRes OUT JSON) AS $$
                DECLARE
                    objSpOutRes TYP_SP_OUT_RES;
                    objFnCheckRes TYP_FN_CHECK_RES;
                    dtmCurrent TIMESTAMP WITH TIME ZONE;
                BEGIN
                    SELECT NOW() INTO dtmCurrent;

                    -- // Duplication Checking in DB FUCTION(Insert and Update)
                    SELECT * FROM  fn_check_data_uniqueness('assets.tbl_assets_sale_write_off_master'::VARCHAR, ''::VARCHAR, ::VARCHAR, 'pk_assets_sale_Write_off_master_id'::VARCHAR, CAST(jsnAssetsSaleWriteOffMaster->>'binAssetsSaleWriteOffMasterId' AS BIGINT)::BIGINT) INTO objFnCheckRes;
                    IF objFnCheckRes.sin_sql_check_status = -1::SMALLINT THEN
                        objSpOutRes.sinSqlCustomStatus := -1::SMALLINT;
                        objSpOutRes.strSqlCustomStatusCode := 'ERROR';
                        objSpOutRes.strSqlCustomMessage := objFnCheckRes.vhr_sql_check_message;

                        objSpOutRes.strSqlCustomErrorType := 'DATABASE_VALIDATION_ERROR';

                        SELECT * FROM  fn_convert_type_out_object_to_out_json(objSpOutRes) INTO jsnSqlRes;
                        RAISE NOTICE 'jsnSqlRes: %', jsnSqlRes;
                        RETURN;
                    END IF;

                    IF CAST(jsnAssetsSaleWriteOffMaster->>'binAssetsSaleWriteOffMasterId' AS BIGINT)::BIGINT = 0::BIGINT THEN
                        -- // Count Exced or other checking License related in DB FUCTION(Insert)
                        

                        --jsnAssetsSaleWriteOffMaster.intSysActionId = 0;
                        --jsnAssetsSaleWriteOffMaster.binCreatedUserId = jsnAssetsSaleWriteOffMaster.linLoginUserId;
                        --jsnAssetsSaleWriteOffMaster.dtmCreated = jsnAssetsSaleWriteOffMaster.dtmCurrentDateTime; --SELECT NOW();

                        INSERT INTO assets.tbl_assets_sale_write_off_master (fk_documents_id,
						fk_depreciation_master_id,

						fk_cost_centre_id,
						sin_if_sale,

						fk_received_cheque_id,
						fk_cc_swap_id,
						vhr_depositor_name,
						vhr_depositor_ref_no,

						vhr_payee_vpa,
						vhr_payee_vpa_bank,

						vhr_virtual_number,
						vhr_virtual_provider,
						vhr_virtual_reference,

						vhr_ledg_currency,
						dbl_ledg_cur_roe,
						dbl_ledg_cur_amount,
						dbl_ledg_cur_bank_charge,

						vhr_base_currency,
						dbl_base_cur_amount,
						dbl_base_cur_bank_charge,

						fk_service_tax_id,
						dbl_sys_perce_of_tax,
						dbl_perce_of_tax,
						dbl_ledg_cur_tax_base_amount,
						dbl_ledg_cur_tax_amount,

						dbl_base_cur_tax_base_amount,
						dbl_base_cur_tax_amount)
                            VALUES(CAST(jsnAssetsSaleWriteOffMaster->>'binDocumentsId' AS BIGINT),
						CAST(jsnAssetsSaleWriteOffMaster->>'binDepreciationMasterId' AS BIGINT),

						CAST(jsnAssetsSaleWriteOffMaster->>'binCostCentreId' AS BIGINT),
						CAST(jsnAssetsSaleWriteOffMaster->>'sinIfSale' AS SMALLINT),

						CAST(jsnAssetsSaleWriteOffMaster->>'binReceivedChequeId' AS BIGINT),
						CAST(jsnAssetsSaleWriteOffMaster->>'binCcSwapId' AS BIGINT),
						jsnAssetsSaleWriteOffMaster->>'strDepositorName',
						jsnAssetsSaleWriteOffMaster->>'strDepositorRefNo',

						jsnAssetsSaleWriteOffMaster->>'strPayeeVpa',
						jsnAssetsSaleWriteOffMaster->>'strPayeeVpaBank',

						jsnAssetsSaleWriteOffMaster->>'strVirtualNumber',
						jsnAssetsSaleWriteOffMaster->>'strVirtualProvider',
						jsnAssetsSaleWriteOffMaster->>'strVirtualReference',

						jsnAssetsSaleWriteOffMaster->>'strLedgCurrency',
						CAST(jsnAssetsSaleWriteOffMaster->>'dblLedgCurRoe' AS DOUBLE PRECISION),
						CAST(jsnAssetsSaleWriteOffMaster->>'dblLedgCurAmount' AS DOUBLE PRECISION),
						CAST(jsnAssetsSaleWriteOffMaster->>'dblLedgCurBankCharge' AS DOUBLE PRECISION),

						jsnAssetsSaleWriteOffMaster->>'strBaseCurrency',
						CAST(jsnAssetsSaleWriteOffMaster->>'dblBaseCurAmount' AS DOUBLE PRECISION),
						CAST(jsnAssetsSaleWriteOffMaster->>'dblBaseCurBankCharge' AS DOUBLE PRECISION),

						CAST(jsnAssetsSaleWriteOffMaster->>'binServiceTaxId' AS BIGINT),
						CAST(jsnAssetsSaleWriteOffMaster->>'dblSysPerceOfTax' AS DOUBLE PRECISION),
						CAST(jsnAssetsSaleWriteOffMaster->>'dblPerceOfTax' AS DOUBLE PRECISION),
						CAST(jsnAssetsSaleWriteOffMaster->>'dblLedgCurTaxBaseAmount' AS DOUBLE PRECISION),
						CAST(jsnAssetsSaleWriteOffMaster->>'dblLedgCurTaxAmount' AS DOUBLE PRECISION),

						CAST(jsnAssetsSaleWriteOffMaster->>'dblBaseCurTaxBaseAmount' AS DOUBLE PRECISION),
						CAST(jsnAssetsSaleWriteOffMaster->>'dblBaseCurTaxAmount' AS DOUBLE PRECISION)) RETURNING pk_assets_sale_Write_off_master_id INTO objSpOutRes.binSqlPk;
                    ELSE
                        -- // UPDATE Check already update another usersin DB FUCTION(Update and Delete)
                        SELECT * FROM  fn_check_already_update_or_delete_another_user('assets.tbl_assets_sale_write_off_master'::VARCHAR, 'pk_assets_sale_Write_off_master_id'::VARCHAR, CAST(jsnAssetsSaleWriteOffMaster->>'binAssetsSaleWriteOffMasterId' AS BIGINT)::BIGINT, CAST(jsnAssetsSaleWriteOffMaster->>'intSysActionId' AS INT)::INT) INTO objFnCheckRes;
                        IF objFnCheckRes.sin_sql_check_status = -1::SMALLINT THEN
                            objSpOutRes.sinSqlCustomStatus := -1::SMALLINT;
                            objSpOutRes.strSqlCustomStatusCode := 'ERROR';
                            objSpOutRes.strSqlCustomMessage := objFnCheckRes.vhr_sql_check_message;

                            objSpOutRes.strSqlCustomErrorType := 'DATABASE_VALIDATION_ERROR';

                            SELECT * FROM  fn_convert_type_out_object_to_out_json(objSpOutRes) INTO jsnSqlRes;
                            RAISE NOTICE 'jsnSqlRes: %', jsnSqlRes;
                            RETURN;
                        END IF;

                        --jsnAssetsSaleWriteOffMaster.intSysActionId = jsnAssetsSaleWriteOffMaster.intSysActionId + 1;
                        --jsnAssetsSaleWriteOffMaster.binLastModifiedUserId = jsnAssetsSaleWriteOffMaster.linLoginUserId;
                        --jsnAssetsSaleWriteOffMaster.dtmLastModified = jsnAssetsSaleWriteOffMaster.dtmCurrentDateTime; --SELECT NOW();

                        UPDATE assets.tbl_assets_sale_write_off_master SET fk_documents_id = CAST(jsnAssetsSaleWriteOffMaster->>'binDocumentsId' AS BIGINT),
						fk_depreciation_master_id = CAST(jsnAssetsSaleWriteOffMaster->>'binDepreciationMasterId' AS BIGINT),

						fk_cost_centre_id = CAST(jsnAssetsSaleWriteOffMaster->>'binCostCentreId' AS BIGINT),
						sin_if_sale = CAST(jsnAssetsSaleWriteOffMaster->>'sinIfSale' AS SMALLINT),

						fk_received_cheque_id = CAST(jsnAssetsSaleWriteOffMaster->>'binReceivedChequeId' AS BIGINT),
						fk_cc_swap_id = CAST(jsnAssetsSaleWriteOffMaster->>'binCcSwapId' AS BIGINT),
						vhr_depositor_name = jsnAssetsSaleWriteOffMaster->>'strDepositorName',
						vhr_depositor_ref_no = jsnAssetsSaleWriteOffMaster->>'strDepositorRefNo',

						vhr_payee_vpa = jsnAssetsSaleWriteOffMaster->>'strPayeeVpa',
						vhr_payee_vpa_bank = jsnAssetsSaleWriteOffMaster->>'strPayeeVpaBank',

						vhr_virtual_number = jsnAssetsSaleWriteOffMaster->>'strVirtualNumber',
						vhr_virtual_provider = jsnAssetsSaleWriteOffMaster->>'strVirtualProvider',
						vhr_virtual_reference = jsnAssetsSaleWriteOffMaster->>'strVirtualReference',

						vhr_ledg_currency = jsnAssetsSaleWriteOffMaster->>'strLedgCurrency',
						dbl_ledg_cur_roe = CAST(jsnAssetsSaleWriteOffMaster->>'dblLedgCurRoe' AS DOUBLE PRECISION),
						dbl_ledg_cur_amount = CAST(jsnAssetsSaleWriteOffMaster->>'dblLedgCurAmount' AS DOUBLE PRECISION),
						dbl_ledg_cur_bank_charge = CAST(jsnAssetsSaleWriteOffMaster->>'dblLedgCurBankCharge' AS DOUBLE PRECISION),

						vhr_base_currency = jsnAssetsSaleWriteOffMaster->>'strBaseCurrency',
						dbl_base_cur_amount = CAST(jsnAssetsSaleWriteOffMaster->>'dblBaseCurAmount' AS DOUBLE PRECISION),
						dbl_base_cur_bank_charge = CAST(jsnAssetsSaleWriteOffMaster->>'dblBaseCurBankCharge' AS DOUBLE PRECISION),

						fk_service_tax_id = CAST(jsnAssetsSaleWriteOffMaster->>'binServiceTaxId' AS BIGINT),
						dbl_sys_perce_of_tax = CAST(jsnAssetsSaleWriteOffMaster->>'dblSysPerceOfTax' AS DOUBLE PRECISION),
						dbl_perce_of_tax = CAST(jsnAssetsSaleWriteOffMaster->>'dblPerceOfTax' AS DOUBLE PRECISION),
						dbl_ledg_cur_tax_base_amount = CAST(jsnAssetsSaleWriteOffMaster->>'dblLedgCurTaxBaseAmount' AS DOUBLE PRECISION),
						dbl_ledg_cur_tax_amount = CAST(jsnAssetsSaleWriteOffMaster->>'dblLedgCurTaxAmount' AS DOUBLE PRECISION),

						dbl_base_cur_tax_base_amount = CAST(jsnAssetsSaleWriteOffMaster->>'dblBaseCurTaxBaseAmount' AS DOUBLE PRECISION),
						dbl_base_cur_tax_amount = CAST(jsnAssetsSaleWriteOffMaster->>'dblBaseCurTaxAmount' AS DOUBLE PRECISION) 
                        WHERE pk_assets_sale_Write_off_master_id = CAST(jsnAssetsSaleWriteOffMaster->>'binAssetsSaleWriteOffMasterId' AS BIGINT);
                    END IF;

                    --COMMIT;
                    objSpOutRes.sinSqlCustomStatus := 1::SMALLINT;
                    objSpOutRes.strSqlCustomStatusCode := 'SUCCESS';
                    objSpOutRes.strSqlCustomMessage := 'AssetsSaleWriteOffMaster Saved';
                    objSpOutRes.dtmCurrent = dtmCurrent;
                    
                    SELECT * FROM  fn_convert_type_out_object_to_out_json(objSpOutRes) INTO jsnSqlRes;
                    RAISE NOTICE 'jsnSqlRes: %', jsnSqlRes;
                    RETURN;
                EXCEPTION WHEN OTHERS THEN
                    ROLLBACK;
                    objSpOutRes.sinSqlCustomStatus := -1::SMALLINT;
                    objSpOutRes.strSqlCustomStatusCode := 'ERROR';
                    objSpOutRes.strSqlCustomMessage := 'AssetsSaleWriteOffMaster Save Failed';

                    objSpOutRes.strSqlCustomErrorType := 'DATABASE_SYSTEM_ERROR';

                    GET STACKED DIAGNOSTICS 
				        objSpOutRes.strSqlSysMessage := MESSAGE_TEXT,
                    	objSpOutRes.strSqlSysExceptionDetail := PG_EXCEPTION_DETAIL,
                    	objSpOutRes.strSqlSysExceptionHint := PG_EXCEPTION_CONTEXT;
                
                    SELECT * FROM  fn_convert_type_out_object_to_out_json(objSpOutRes) INTO jsnSqlRes;
                    RAISE EXCEPTION 'jsnSqlRes: %', jsnSqlRes;
                    RETURN;
                END;
            $$ LANGUAGE plpgsql;
        

------------------------------------------------------------------------------------------

            CREATE OR REPLACE PROCEDURE sp_delete_assets_sale_write_off_master(binAssetsSaleWriteOffMasterId BIGINT, intSysActionId INT, binDeletedUserId BIGINT, jsnSqlRes OUT JSON) AS $$
                DECLARE
                    objSpOutRes TYP_SP_OUT_RES;
                    objFnCheckRes TYP_FN_CHECK_RES;
                    dtmCurrent TIMESTAMP WITH TIME ZONE;
                BEGIN
                    SELECT NOW() INTO dtmCurrent;

                    -- // FOREIGN KEY REFERENCES Checking in DB FUCTION(Delete)
                    SELECT * FROM  fn_check_foreignkey_referance('tbl_assets_sale_write_off_master'::VARCHAR, 'pk_assets_sale_Write_off_master_id'::VARCHAR, binAssetsSaleWriteOffMasterId::BIGINT, '{}'::VARCHAR ARRAY) INTO objFnCheckRes;
                    IF objFnCheckRes.sin_sql_check_status = -1::SMALLINT THEN
                        objSpOutRes.sinSqlCustomStatus := -1::SMALLINT;
                        objSpOutRes.strSqlCustomStatusCode := 'ERROR';
                        objSpOutRes.strSqlCustomMessage := objFnCheckRes.vhr_sql_check_message;

                        objSpOutRes.strSqlCustomErrorType := 'DATABASE_VALIDATION_ERROR';

                        SELECT * FROM  fn_convert_type_out_object_to_out_json(objSpOutRes) INTO jsnSqlRes;
                        RAISE NOTICE 'jsnSqlRes: %', jsnSqlRes;
                        RETURN;
                    END IF;

                    -- // UPDATE Check already update another users in DB FUCTION(Update and Delete)
                    SELECT * FROM  fn_check_already_update_or_delete_another_user('assets.tbl_assets_sale_write_off_master'::VARCHAR, 'pk_assets_sale_Write_off_master_id'::VARCHAR, CAST(binAssetsSaleWriteOffMasterId AS BIGINT)::BIGINT, intSysActionId::INT) INTO objFnCheckRes;
                    IF objFnCheckRes.sin_sql_check_status = -1::SMALLINT THEN
                        objSpOutRes.sinSqlCustomStatus := -1::SMALLINT;
                        objSpOutRes.strSqlCustomStatusCode := 'ERROR';
                        objSpOutRes.strSqlCustomMessage := objFnCheckRes.vhr_sql_check_message;

                        objSpOutRes.strSqlCustomErrorType := 'DATABASE_VALIDATION_ERROR';

                        SELECT * FROM  fn_convert_type_out_object_to_out_json(objSpOutRes) INTO jsnSqlRes;
                        RAISE NOTICE 'jsnSqlRes: %', jsnSqlRes;
                        RETURN;
                    END IF;

                    --dtmDeleted = SELECT NOW();
                    UPDATE assets.tbl_assets_sale_write_off_master SET int_sys_action_id = -1::INT,
                                fk_deleted_user_id = binDeletedUserId,
                                dtm_deleted = dtmCurrent
                        WHERE pk_assets_sale_Write_off_master_id = binAssetsSaleWriteOffMasterId;

                    --COMMIT;
                    objSpOutRes.sinSqlCustomStatus := 1::SMALLINT;
                    objSpOutRes.strSqlCustomStatusCode := 'SUCCESS';
                    objSpOutRes.strSqlCustomMessage := 'AssetsSaleWriteOffMaster Deleted';
                    objSpOutRes.dtmCurrent = dtmCurrent;

                    SELECT * FROM fn_convert_type_out_object_to_out_json(objSpOutRes) INTO jsnSqlRes;
                    RAISE NOTICE 'jsnSqlRes: %', jsnSqlRes;
                    RETURN;
                EXCEPTION WHEN OTHERS THEN
                    ROLLBACK;
                    objSpOutRes.sinSqlCustomStatus := -1::SMALLINT;
                    objSpOutRes.strSqlCustomStatusCode := 'ERROR';
                    objSpOutRes.strSqlCustomMessage := 'AssetsSaleWriteOffMaster Delete Failed';

                    objSpOutRes.strSqlCustomErrorType := 'DATABASE_SYSTEM_ERROR';

                    GET STACKED DIAGNOSTICS 
				        objSpOutRes.strSqlSysMessage := MESSAGE_TEXT,
                    	objSpOutRes.strSqlSysExceptionDetail := PG_EXCEPTION_DETAIL,
                    	objSpOutRes.strSqlSysExceptionHint := PG_EXCEPTION_CONTEXT;

                    SELECT * FROM fn_convert_type_out_object_to_out_json(objSpOutRes) INTO jsnSqlRes;
                    RAISE EXCEPTION 'jsnSqlRes: %', jsnSqlRes;
                    RETURN;
                END;
            $$ LANGUAGE plpgsql;
        

